//
//  THImageBrowserContentLayer.h
//  ArtGallery
//
//  Created by Scott Stevenson on 11/27/07.
//  Released under a BSD-style license. See License.txt
//

#import <Cocoa/Cocoa.h>
#import <QuartzCore/QuartzCore.h>

@interface THImageBrowserContentLayer : CALayer {
    
    CALayer*        _imageLayer;
    CALayer*        _imageLayerAlternate;
    CATextLayer*    _textLayer;
    BOOL            _shouldDisplayMonochromeImage;
}

// create a new layer with the target content size and image
+ (id)layerWithContentSize:(CGSize)baseContentSize andImage:(NSImage*)image;

// main content image
@property (readonly) CGImageRef contentImage;

// title below image
@property (copy) NSString* title;

// sets whether to display the primary or alternate image
@property BOOL shouldDisplayMonochromeImage;

// reverses the current state of shouldDisplayMonochromeImage
- (void)toggleMonochromeState;

// sent by superlayer when mouse is clicked within this layer's frame
- (void)mouseDownAtPointInSuperlayer:(CGPoint)inputPoint;

@end
