//
//  THImageBrowserView.h
//  ArtGallery
//
//  Created by Scott Stevenson on 11/20/07.
//  Released under a BSD-style license. See License.txt
//

#import <Cocoa/Cocoa.h>

@class THImageBrowserContentLayer;

@interface THImageBrowserView : NSView {

    NSArray*    _imageDataDictionaries;
    NSUInteger  _currentImageIndex;
    CGSize      _baseContentSize;
    CGFloat     _visibleMarginForNextImage;
    
    @private

    CALayer*    _contentContainerLayer;
    THImageBrowserContentLayer*    _previousContentLayer;
    THImageBrowserContentLayer*    _currentContentLayer;
    THImageBrowserContentLayer*    _nextContentLayer;
    CGRect      _previousNavRect;
    CGRect      _nextNavRect;
    CALayer*    _navControlContainerLayer;
    CALayer*    _navControlLeftLayer;
    CALayer*    _navControlRightLayer;    
    CALayer*    _leftShadow;
    CALayer*    _rightShadow;
    NSEventType _navigationEventType;
}

// contains the source data for image content
@property (copy) NSArray* imageDataDictionaries;

// index into the imageDataDictionaries array
@property NSUInteger currentImageIndex;

// basic layout
@property CGSize baseContentSize;
@property CGFloat visibleMarginForNextImage;

// action methods for moving left and right
- (IBAction)moveToPreviousImage:(id)anArgument;
- (IBAction)moveToNextImage:(id)anArgument;

// controls navigation UI
- (void)showNavigation;
- (void)hideNavigation;
- (void)refreshNavigationState;


@end
